//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_bc "bufio";_gd "bytes";_d "encoding/hex";_f "errors";_b "fmt";_bb "github.com/unidoc/unipdf/v3/common";_ca "github.com/unidoc/unipdf/v3/core";_eg "io";_cg "os";_e "regexp";_gb "sort";_ff "strconv";_c "strings";);

// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_ca .PdfObjectDictionary ,error ){_bf :=map[string ]*_ca .PdfObjectDictionary {};for _cgf :=0;_cgf < fdf ._a .Len ();_cgf ++{_gg ,_bcg :=_ca .GetDict (fdf ._a .Get (_cgf ));if _bcg {_fd ,_ :=_ca .GetString (_gg .Get ("\u0054"));
if _fd !=nil {_bf [_fd .Str ()]=_gg ;};};};return _bf ,nil ;};func (_dbd *fdfParser )parseObject ()(_ca .PdfObject ,error ){_bb .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");_dbd .skipSpaces ();
for {_caf ,_afd :=_dbd ._ggcd .Peek (2);if _afd !=nil {return nil ,_afd ;};_bb .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_caf ));if _caf [0]=='/'{_ecf ,_gec :=_dbd .parseName ();_bb .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_ecf );
return &_ecf ,_gec ;}else if _caf [0]=='('{_bb .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _dbd .parseString ();}else if _caf [0]=='['{_bb .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");return _dbd .parseArray ();
}else if (_caf [0]=='<')&&(_caf [1]=='<'){_bb .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _dbd .parseDict ();}else if _caf [0]=='<'{_bb .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");return _dbd .parseHexString ();
}else if _caf [0]=='%'{_dbd .readComment ();_dbd .skipSpaces ();}else {_bb .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_caf ,_ =_dbd ._ggcd .Peek (15);_ccbb :=string (_caf );_bb .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_ccbb );
if (len (_ccbb )> 3)&&(_ccbb [:4]=="\u006e\u0075\u006c\u006c"){_abb ,_ffbe :=_dbd .parseNull ();return &_abb ,_ffbe ;}else if (len (_ccbb )> 4)&&(_ccbb [:5]=="\u0066\u0061\u006cs\u0065"){_cd ,_dbg :=_dbd .parseBool ();return &_cd ,_dbg ;}else if (len (_ccbb )> 3)&&(_ccbb [:4]=="\u0074\u0072\u0075\u0065"){_eec ,_cba :=_dbd .parseBool ();
return &_eec ,_cba ;};_caef :=_gdf .FindStringSubmatch (_ccbb );if len (_caef )> 1{_caf ,_ =_dbd ._ggcd .ReadBytes ('R');_bb .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_caf [:]));_bafc ,_befb :=_aef (string (_caf ));
return &_bafc ,_befb ;};_ce :=_aeg .FindStringSubmatch (_ccbb );if len (_ce )> 1{_bb .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _dbd .parseNumber ();};_ce =_ccd .FindStringSubmatch (_ccbb );if len (_ce )> 1{_bb .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");
_bb .Log .Trace ("\u0025\u0020\u0073",_ce );return _dbd .parseNumber ();};_bb .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_ccbb );return nil ,_f .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");
};};};type fdfParser struct{_fbb int ;_faad int ;_dc map[int64 ]_ca .PdfObject ;_fec _eg .ReadSeeker ;_ggcd *_bc .Reader ;_ee int64 ;_bgdf *_ca .PdfObjectDictionary ;};var _fc =_e .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");
var _eag =_e .MustCompile ("\u0025\u0025\u0045O\u0046");func (_be *fdfParser )skipComments ()error {if _ ,_ecb :=_be .skipSpaces ();_ecb !=nil {return _ecb ;};_baa :=true ;for {_aad ,_adf :=_be ._ggcd .Peek (1);if _adf !=nil {_bb .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_adf .Error ());
return _adf ;};if _baa &&_aad [0]!='%'{return nil ;};_baa =false ;if (_aad [0]!='\r')&&(_aad [0]!='\n'){_be ._ggcd .ReadByte ();}else {break ;};};return _be .skipComments ();};

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_cc ,_ge :=_cg .Open (fdfPath );if _ge !=nil {return nil ,_ge ;};defer _cc .Close ();return Load (_cc );};func (_ggcc *fdfParser )skipSpaces ()(int ,error ){_egb :=0;for {_bag ,_ac :=_ggcc ._ggcd .ReadByte ();
if _ac !=nil {return 0,_ac ;};if _ca .IsWhiteSpace (_bag ){_egb ++;}else {_ggcc ._ggcd .UnreadByte ();break ;};};return _egb ,nil ;};func (_fdd *fdfParser )parseArray ()(*_ca .PdfObjectArray ,error ){_ecbb :=_ca .MakeArray ();_fdd ._ggcd .ReadByte ();for {_fdd .skipSpaces ();
_ebbg ,_gae :=_fdd ._ggcd .Peek (1);if _gae !=nil {return _ecbb ,_gae ;};if _ebbg [0]==']'{_fdd ._ggcd .ReadByte ();break ;};_gba ,_gae :=_fdd .parseObject ();if _gae !=nil {return _ecbb ,_gae ;};_ecbb .Append (_gba );};return _ecbb ,nil ;};var _aeg =_e .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");


// Root returns the Root of the FDF document.
func (_abbb *fdfParser )Root ()(*_ca .PdfObjectDictionary ,error ){if _abbb ._bgdf !=nil {if _dg ,_addd :=_abbb .trace (_abbb ._bgdf .Get ("\u0052\u006f\u006f\u0074")).(*_ca .PdfObjectDictionary );_addd {if _caec ,_abf :=_abbb .trace (_dg .Get ("\u0046\u0044\u0046")).(*_ca .PdfObjectDictionary );
_abf {return _caec ,nil ;};};};var _dd []int64 ;for _eeb :=range _abbb ._dc {_dd =append (_dd ,_eeb );};_gb .Slice (_dd ,func (_cccd ,_aca int )bool {return _dd [_cccd ]< _dd [_aca ]});for _ ,_dga :=range _dd {_bbd :=_abbb ._dc [_dga ];if _cca ,_cfe :=_abbb .trace (_bbd ).(*_ca .PdfObjectDictionary );
_cfe {if _fcbe ,_ggca :=_abbb .trace (_cca .Get ("\u0046\u0044\u0046")).(*_ca .PdfObjectDictionary );_ggca {return _fcbe ,nil ;};};};return nil ,_f .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func (_ad *fdfParser )readAtLeast (_fg []byte ,_gda int )(int ,error ){_ea :=_gda ;
_gef :=0;_db :=0;for _ea > 0{_faa ,_egg :=_ad ._ggcd .Read (_fg [_gef :]);if _egg !=nil {_bb .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_faa ,_db ,_egg .Error ());
return _gef ,_f .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_db ++;_gef +=_faa ;_ea -=_faa ;};return _gef ,nil ;};

// Data represents forms data format (FDF) file data.
type Data struct{_eb *_ca .PdfObjectDictionary ;_a *_ca .PdfObjectArray ;};func (_bbf *fdfParser )getFileOffset ()int64 {_bd ,_ :=_bbf ._fec .Seek (0,_eg .SeekCurrent );_bd -=int64 (_bbf ._ggcd .Buffered ());return _bd ;};var _ccd =_e .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");
func (_gdad *fdfParser )seekToEOFMarker (_aaf int64 )error {_cbc :=int64 (0);_ecdc :=int64 (1000);for _cbc < _aaf {if _aaf <=(_ecdc +_cbc ){_ecdc =_aaf -_cbc ;};_ ,_fcb :=_gdad ._fec .Seek (-_cbc -_ecdc ,_eg .SeekEnd );if _fcb !=nil {return _fcb ;};_caefb :=make ([]byte ,_ecdc );
_gdad ._fec .Read (_caefb );_bb .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_caefb ));_cde :=_eag .FindAllStringIndex (string (_caefb ),-1);
if _cde !=nil {_ag :=_cde [len (_cde )-1];_bb .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_cde );_gdad ._fec .Seek (-_cbc -_ecdc +int64 (_ag [0]),_eg .SeekEnd );return nil ;};_bb .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");
_cbc +=_ecdc ;};_bb .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _f .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
};func (_dbc *fdfParser )parseBool ()(_ca .PdfObjectBool ,error ){_geg ,_cce :=_dbc ._ggcd .Peek (4);if _cce !=nil {return _ca .PdfObjectBool (false ),_cce ;};if (len (_geg )>=4)&&(string (_geg [:4])=="\u0074\u0072\u0075\u0065"){_dbc ._ggcd .Discard (4);
return _ca .PdfObjectBool (true ),nil ;};_geg ,_cce =_dbc ._ggcd .Peek (5);if _cce !=nil {return _ca .PdfObjectBool (false ),_cce ;};if (len (_geg )>=5)&&(string (_geg [:5])=="\u0066\u0061\u006cs\u0065"){_dbc ._ggcd .Discard (5);return _ca .PdfObjectBool (false ),nil ;
};return _ca .PdfObjectBool (false ),_f .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");};func (_abd *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_abd ._fec .Seek (0,_eg .SeekStart );
_abd ._ggcd =_bc .NewReader (_abd ._fec );_bbef :=20;_eab :=make ([]byte ,_bbef );for {_dfdd ,_cbgf :=_abd ._ggcd .ReadByte ();if _cbgf !=nil {if _cbgf ==_eg .EOF {break ;}else {return 0,0,_cbgf ;};};if _ca .IsDecimalDigit (_dfdd )&&_eab [_bbef -1]=='.'&&_ca .IsDecimalDigit (_eab [_bbef -2])&&_eab [_bbef -3]=='-'&&_eab [_bbef -4]=='F'&&_eab [_bbef -5]=='D'&&_eab [_bbef -6]=='P'{_bcga :=int (_eab [_bbef -2]-'0');
_edc :=int (_dfdd -'0');return _bcga ,_edc ,nil ;};_eab =append (_eab [1:_bbef ],_dfdd );};return 0,0,_f .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};func (_cbaa *fdfParser )parseFdfVersion ()(int ,int ,error ){_cbaa ._fec .Seek (0,_eg .SeekStart );
_cad :=20;_gaec :=make ([]byte ,_cad );_cbaa ._fec .Read (_gaec );_cge :=_fc .FindStringSubmatch (string (_gaec ));if len (_cge )< 3{_fbbg ,_cgfd ,_bbee :=_cbaa .seekFdfVersionTopDown ();if _bbee !=nil {_bb .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");
return 0,0,_bbee ;};return _fbbg ,_cgfd ,nil ;};_fad ,_abc :=_ff .Atoi (_cge [1]);if _abc !=nil {return 0,0,_abc ;};_gdae ,_abc :=_ff .Atoi (_cge [2]);if _abc !=nil {return 0,0,_abc ;};_bb .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_fad ,_gdae );
return _fad ,_gdae ,nil ;};func (_feg *fdfParser )parseHexString ()(*_ca .PdfObjectString ,error ){_feg ._ggcd .ReadByte ();var _edf _gd .Buffer ;for {_efaa ,_bda :=_feg ._ggcd .Peek (1);if _bda !=nil {return _ca .MakeHexString (""),_bda ;};if _efaa [0]=='>'{_feg ._ggcd .ReadByte ();
break ;};_eee ,_ :=_feg ._ggcd .ReadByte ();if !_ca .IsWhiteSpace (_eee ){_edf .WriteByte (_eee );};};if _edf .Len ()%2==1{_edf .WriteRune ('0');};_eed ,_adc :=_d .DecodeString (_edf .String ());if _adc !=nil {_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_edf .String ());
return _ca .MakeHexString (""),nil ;};return _ca .MakeHexString (string (_eed )),nil ;};func (_bgda *fdfParser )parseNull ()(_ca .PdfObjectNull ,error ){_ ,_bega :=_bgda ._ggcd .Discard (4);return _ca .PdfObjectNull {},_bega ;};

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_ca .PdfObject ,error ){_fe ,_fb :=fdf .FieldDictionaries ();if _fb !=nil {return nil ,_fb ;};var _fa []string ;for _eba :=range _fe {_fa =append (_fa ,_eba );};_gb .Strings (_fa );_cb :=map[string ]_ca .PdfObject {};
for _ ,_aa :=range _fa {_ae :=_fe [_aa ];_af :=_ca .TraceToDirectObject (_ae .Get ("\u0056"));_cb [_aa ]=_af ;};return _cb ,nil ;};func (_fada *fdfParser )trace (_bagd _ca .PdfObject )_ca .PdfObject {switch _ggbe :=_bagd .(type ){case *_ca .PdfObjectReference :_fce ,_cadf :=_fada ._dc [_ggbe .ObjectNumber ].(*_ca .PdfIndirectObject );
if _cadf {return _fce .PdfObject ;};_bb .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_ca .PdfIndirectObject :return _ggbe .PdfObject ;};return _bagd ;};var _gga =_e .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");
func (_ced *fdfParser )parseIndirectObject ()(_ca .PdfObject ,error ){_ggf :=_ca .PdfIndirectObject {};_bb .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");_eea ,_aee :=_ced ._ggcd .Peek (20);if _aee !=nil {_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return &_ggf ,_aee ;};_bb .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_eea ));_fdb :=_gga .FindStringSubmatchIndex (string (_eea ));if len (_fdb )< 6{_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_eea ));
return &_ggf ,_f .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_ced ._ggcd .Discard (_fdb [0]);_bb .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_fdb );_gdd :=_fdb [1]-_fdb [0];_adca :=make ([]byte ,_gdd );_ ,_aee =_ced .readAtLeast (_adca ,_gdd );if _aee !=nil {_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_aee );
return nil ,_aee ;};_bb .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_adca );_abbc :=_gga .FindStringSubmatch (string (_adca ));if len (_abbc )< 3{_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_adca ));
return &_ggf ,_f .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_gf ,_ :=_ff .Atoi (_abbc [1]);_dfb ,_ :=_ff .Atoi (_abbc [2]);_ggf .ObjectNumber =int64 (_gf );_ggf .GenerationNumber =int64 (_dfb );for {_ega ,_agg :=_ced ._ggcd .Peek (2);if _agg !=nil {return &_ggf ,_agg ;};_bb .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_ega ),string (_ega ));
if _ca .IsWhiteSpace (_ega [0]){_ced .skipSpaces ();}else if _ega [0]=='%'{_ced .skipComments ();}else if (_ega [0]=='<')&&(_ega [1]=='<'){_bb .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_ggf .PdfObject ,_agg =_ced .parseDict ();
_bb .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_agg );if _agg !=nil {return &_ggf ,_agg ;};_bb .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");
}else if (_ega [0]=='/')||(_ega [0]=='(')||(_ega [0]=='[')||(_ega [0]=='<'){_ggf .PdfObject ,_agg =_ced .parseObject ();if _agg !=nil {return &_ggf ,_agg ;};_bb .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");
}else {if _ega [0]=='e'{_bfg ,_ggd :=_ced .readTextLine ();if _ggd !=nil {return nil ,_ggd ;};if len (_bfg )>=6&&_bfg [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _ega [0]=='s'{_ega ,_ =_ced ._ggcd .Peek (10);if string (_ega [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_fgff :=6;
if len (_ega )> 6{if _ca .IsWhiteSpace (_ega [_fgff ])&&_ega [_fgff ]!='\r'&&_ega [_fgff ]!='\n'{_bb .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");
_fgff ++;};if _ega [_fgff ]=='\r'{_fgff ++;if _ega [_fgff ]=='\n'{_fgff ++;};}else if _ega [_fgff ]=='\n'{_fgff ++;};};_ced ._ggcd .Discard (_fgff );_aeb ,_aeca :=_ggf .PdfObject .(*_ca .PdfObjectDictionary );if !_aeca {return nil ,_f .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");
};_bb .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_aeb );_cbca ,_efc :=_aeb .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_ca .PdfObjectInteger );if !_efc {return nil ,_f .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");
};_eda :=*_cbca ;if _eda < 0{return nil ,_f .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_eda )> _ced ._ee {_bb .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");
return nil ,_f .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_gaa :=make ([]byte ,_eda );
_ ,_agg =_ced .readAtLeast (_gaa ,int (_eda ));if _agg !=nil {_bb .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_gaa ),_gaa );_bb .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_agg );
return nil ,_agg ;};_eead :=_ca .PdfObjectStream {};_eead .Stream =_gaa ;_eead .PdfObjectDictionary =_ggf .PdfObject .(*_ca .PdfObjectDictionary );_eead .ObjectNumber =_ggf .ObjectNumber ;_eead .GenerationNumber =_ggf .GenerationNumber ;_ced .skipSpaces ();
_ced ._ggcd .Discard (9);_ced .skipSpaces ();return &_eead ,nil ;};};_ggf .PdfObject ,_agg =_ced .parseObject ();return &_ggf ,_agg ;};};_bb .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");
return &_ggf ,nil ;};func (_gcg *fdfParser )parse ()error {_gcg ._fec .Seek (0,_eg .SeekStart );_gcg ._ggcd =_bc .NewReader (_gcg ._fec );for {_gcg .skipComments ();_dec ,_cec :=_gcg ._ggcd .Peek (20);if _cec !=nil {_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return _cec ;};if _c .HasPrefix (string (_dec ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_gcg ._ggcd .Discard (7);_gcg .skipSpaces ();_gcg .skipComments ();_deae ,_ :=_gcg .parseDict ();_gcg ._bgdf =_deae ;break ;};_dfd :=_gga .FindStringSubmatchIndex (string (_dec ));
if len (_dfd )< 6{_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_dec ));
return _f .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_agb ,_cec :=_gcg .parseIndirectObject ();if _cec !=nil {return _cec ;};switch _bdf :=_agb .(type ){case *_ca .PdfIndirectObject :_gcg ._dc [_bdf .ObjectNumber ]=_bdf ;case *_ca .PdfObjectStream :_gcg ._dc [_bdf .ObjectNumber ]=_bdf ;default:return _f .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");
};};return nil ;};func _aef (_dcc string )(_ca .PdfObjectReference ,error ){_ged :=_ca .PdfObjectReference {};_ab :=_gdf .FindStringSubmatch (_dcc );if len (_ab )< 3{_bb .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");
return _ged ,_f .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");};_ecd ,_cfc :=_ff .Atoi (_ab [1]);if _cfc !=nil {_bb .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_ab [1]);
return _ged ,nil ;};_ged .ObjectNumber =int64 (_ecd );_acf ,_cfc :=_ff .Atoi (_ab [2]);if _cfc !=nil {_bb .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_ab [2]);
return _ged ,nil ;};_ged .GenerationNumber =int64 (_acf );return _ged ,nil ;};func _bbec (_fde _eg .ReadSeeker )(*fdfParser ,error ){_ded :=&fdfParser {};_ded ._fec =_fde ;_ded ._dc =map[int64 ]_ca .PdfObject {};_ccea ,_ffe ,_bgg :=_ded .parseFdfVersion ();
if _bgg !=nil {_bb .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_bgg );return nil ,_bgg ;};_ded ._fbb =_ccea ;_ded ._faad =_ffe ;_bgg =_ded .parse ();
return _ded ,_bgg ;};func (_gdg *fdfParser )readTextLine ()(string ,error ){var _dcd _gd .Buffer ;for {_bcb ,_dcb :=_gdg ._ggcd .Peek (1);if _dcb !=nil {_bb .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_dcb .Error ());return _dcd .String (),_dcb ;
};if (_bcb [0]!='\r')&&(_bcb [0]!='\n'){_cbg ,_ :=_gdg ._ggcd .ReadByte ();_dcd .WriteByte (_cbg );}else {break ;};};return _dcd .String (),nil ;};var _gdf =_e .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");
func (_bge *fdfParser )parseNumber ()(_ca .PdfObject ,error ){return _ca .ParseNumber (_bge ._ggcd )};func _gfb (_bea string )(*fdfParser ,error ){_bcf :=fdfParser {};_ffa :=[]byte (_bea );_bfd :=_gd .NewReader (_ffa );_bcf ._fec =_bfd ;_bcf ._dc =map[int64 ]_ca .PdfObject {};
_dea :=_bc .NewReader (_bfd );_bcf ._ggcd =_dea ;_bcf ._ee =int64 (len (_bea ));return &_bcf ,_bcf .parse ();};func (_bagc *fdfParser )parseName ()(_ca .PdfObjectName ,error ){var _eaa _gd .Buffer ;_egf :=false ;for {_ef ,_gc :=_bagc ._ggcd .Peek (1);if _gc ==_eg .EOF {break ;
};if _gc !=nil {return _ca .PdfObjectName (_eaa .String ()),_gc ;};if !_egf {if _ef [0]=='/'{_egf =true ;_bagc ._ggcd .ReadByte ();}else if _ef [0]=='%'{_bagc .readComment ();_bagc .skipSpaces ();}else {_bb .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_ef ,_ef );
return _ca .PdfObjectName (_eaa .String ()),_b .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_ef [0]);};}else {if _ca .IsWhiteSpace (_ef [0]){break ;}else if (_ef [0]=='/')||(_ef [0]=='[')||(_ef [0]=='(')||(_ef [0]==']')||(_ef [0]=='<')||(_ef [0]=='>'){break ;
}else if _ef [0]=='#'{_ffb ,_ga :=_bagc ._ggcd .Peek (3);if _ga !=nil {return _ca .PdfObjectName (_eaa .String ()),_ga ;};_bagc ._ggcd .Discard (3);_bbb ,_ga :=_d .DecodeString (string (_ffb [1:3]));if _ga !=nil {return _ca .PdfObjectName (_eaa .String ()),_ga ;
};_eaa .Write (_bbb );}else {_cgb ,_ :=_bagc ._ggcd .ReadByte ();_eaa .WriteByte (_cgb );};};};return _ca .PdfObjectName (_eaa .String ()),nil ;};func (_fef *fdfParser )parseDict ()(*_ca .PdfObjectDictionary ,error ){_bb .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");
_fbd :=_ca .MakeDict ();_gag ,_ :=_fef ._ggcd .ReadByte ();if _gag !='<'{return nil ,_f .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_gag ,_ =_fef ._ggcd .ReadByte ();if _gag !='<'{return nil ,_f .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");
};for {_fef .skipSpaces ();_fef .skipComments ();_dca ,_bbc :=_fef ._ggcd .Peek (2);if _bbc !=nil {return nil ,_bbc ;};_bb .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_dca ),string (_dca ));
if (_dca [0]=='>')&&(_dca [1]=='>'){_bb .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_fef ._ggcd .ReadByte ();_fef ._ggcd .ReadByte ();break ;};_bb .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");
_bgab ,_bbc :=_fef .parseName ();_bb .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_bgab );if _bbc !=nil {_bb .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_bbc );
return nil ,_bbc ;};if len (_bgab )> 4&&_bgab [len (_bgab )-4:]=="\u006e\u0075\u006c\u006c"{_ecc :=_bgab [0:len (_bgab )-4];_bb .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_bgab );
_bb .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_ecc );_fef .skipSpaces ();_eggb ,_ :=_fef ._ggcd .Peek (1);if _eggb [0]=='/'{_fbd .Set (_ecc ,_ca .MakeNull ());continue ;};};_fef .skipSpaces ();
_cggc ,_bbc :=_fef .parseObject ();if _bbc !=nil {return nil ,_bbc ;};_fbd .Set (_bgab ,_cggc );_bb .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_bgab ,_cggc .String ());};_bb .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");
return _fbd ,nil ;};func (_dbf *fdfParser )readComment ()(string ,error ){var _fcg _gd .Buffer ;_ ,_egd :=_dbf .skipSpaces ();if _egd !=nil {return _fcg .String (),_egd ;};_dbb :=true ;for {_bad ,_bdb :=_dbf ._ggcd .Peek (1);if _bdb !=nil {_bb .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_bdb .Error ());
return _fcg .String (),_bdb ;};if _dbb &&_bad [0]!='%'{return _fcg .String (),_f .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");};_dbb =false ;if (_bad [0]!='\r')&&(_bad [0]!='\n'){_aea ,_ :=_dbf ._ggcd .ReadByte ();
_fcg .WriteByte (_aea );}else {break ;};};return _fcg .String (),nil ;};func (_cae *fdfParser )parseString ()(*_ca .PdfObjectString ,error ){_cae ._ggcd .ReadByte ();var _fgf _gd .Buffer ;_ccbg :=1;for {_cf ,_cgg :=_cae ._ggcd .Peek (1);if _cgg !=nil {return _ca .MakeString (_fgf .String ()),_cgg ;
};if _cf [0]=='\\'{_cae ._ggcd .ReadByte ();_add ,_afa :=_cae ._ggcd .ReadByte ();if _afa !=nil {return _ca .MakeString (_fgf .String ()),_afa ;};if _ca .IsOctalDigit (_add ){_bef ,_bgdb :=_cae ._ggcd .Peek (2);if _bgdb !=nil {return _ca .MakeString (_fgf .String ()),_bgdb ;
};var _efd []byte ;_efd =append (_efd ,_add );for _ ,_ebb :=range _bef {if _ca .IsOctalDigit (_ebb ){_efd =append (_efd ,_ebb );}else {break ;};};_cae ._ggcd .Discard (len (_efd )-1);_bb .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_efd );
_efa ,_bgdb :=_ff .ParseUint (string (_efd ),8,32);if _bgdb !=nil {return _ca .MakeString (_fgf .String ()),_bgdb ;};_fgf .WriteByte (byte (_efa ));continue ;};switch _add {case 'n':_fgf .WriteRune ('\n');case 'r':_fgf .WriteRune ('\r');case 't':_fgf .WriteRune ('\t');
case 'b':_fgf .WriteRune ('\b');case 'f':_fgf .WriteRune ('\f');case '(':_fgf .WriteRune ('(');case ')':_fgf .WriteRune (')');case '\\':_fgf .WriteRune ('\\');};continue ;}else if _cf [0]=='('{_ccbg ++;}else if _cf [0]==')'{_ccbg --;if _ccbg ==0{_cae ._ggcd .ReadByte ();
break ;};};_eaf ,_ :=_cae ._ggcd .ReadByte ();_fgf .WriteByte (_eaf );};return _ca .MakeString (_fgf .String ()),nil ;};

// Load loads FDF form data from `r`.
func Load (r _eg .ReadSeeker )(*Data ,error ){_ed ,_ec :=_bbec (r );if _ec !=nil {return nil ,_ec ;};_ba ,_ec :=_ed .Root ();if _ec !=nil {return nil ,_ec ;};_edb ,_bg :=_ca .GetArray (_ba .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_bg {return nil ,_f .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");
};return &Data {_a :_edb ,_eb :_ba },nil ;};func (_bbe *fdfParser )setFileOffset (_ggb int64 ){_bbe ._fec .Seek (_ggb ,_eg .SeekStart );_bbe ._ggcd =_bc .NewReader (_bbe ._fec );};